GDAL-VECTOR-SET-GEOM-TYPE(1)

NAME
gdal-vector-set-geom-type - Modify the geometry type of a vector dataset

Added in version 3.12.

SYNOPSIS

            Usage: gdal vector set-geom-type [OPTIONS] <INPUT> <OUTPUT>

            Modify the geometry type of a vector dataset.

            Positional arguments:
              -i, --input <INPUT>                                  Input vector datasets [required]
              -o, --output <OUTPUT>                                Output vector dataset [required]

            Common Options:
              -h, --help                                           Display help message and exit
              --json-usage                                         Display usage as JSON document and exit
              --config <KEY>=<VALUE>                               Configuration option [may be repeated]
              -q, --quiet                                          Quiet mode (no progress bar)

            Options:
              -l, --layer, --input-layer <INPUT-LAYER>             Input layer name(s) [may be repeated]
              -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
              --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
              --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated]
              --overwrite                                          Whether overwriting existing output is allowed
              --update                                             Whether to open existing dataset in update mode
              --overwrite-layer                                    Whether overwriting existing output is allowed
              --append                                             Whether appending to existing layer is allowed
                                                                   Mutually exclusive with --upsert
              --output-layer <OUTPUT-LAYER>                        Output layer name
              --skip-errors                                        Skip errors when writing features
              --active-layer <ACTIVE-LAYER>                        Set active layer (if not specified, all)
              --active-geometry <ACTIVE-GEOMETRY>                  Geometry field name to which to restrict the processing (if not specified, all)
              --layer-only                                         Only modify the layer geometry type
                                                                   Mutually exclusive with --feature-only
              --feature-only                                       Only modify the geometry type of features
                                                                   Mutually exclusive with --layer-only
              --geometry-type <GEOMETRY-TYPE>                      Geometry type
              --multi                                              Force geometries to MULTI geometry types
                                                                   Mutually exclusive with --single
              --single                                             Force geometries to non-MULTI geometry types
                                                                   Mutually exclusive with --multi
              --linear                                             Convert curve geometries to linear types
                                                                   Mutually exclusive with --curve
              --curve                                              Convert linear geometries to curve types
                                                                   Mutually exclusive with --linear
              --dim <DIM>                                          Force geometries to the specified dimension. DIM=XY|XYZ|XYM|XYZM
              --skip                                               Skip feature when change of feature geometry type failed

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
              --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]
              --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated]
              --upsert                                             Upsert features (implies 'append')
                                                                   Mutually exclusive with --append

DESCRIPTION

gdal vector set-geom-type can be used to modify the geometry type of geometry fields at the layer and/or feature level.

It can also be used as a step of gdal vector pipeline.

The following groups of options can be combined together: - --multi / --single - --linear / --curve - --dim

  Standard options

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

        May be repeated.

        The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

        Note that dataset creation options are different from layer creation options.

    -lco <NAME>=<VALUE>
        Layer creation option (format specific)

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

    --active-layer <ACTIVE-LAYER>
        Set the active layer. When it is specified, only the layer specified by its name will be subject to the processing. Other layers will be not modified. If this option is not specified, all layers will be subject to the processing.

    --active-geometry <ACTIVE-GEOMETRY>
        Set the active geometry field from its name. When it is specified, only the specified geometry field will be subject to the processing. Other geometry fields will be not modified. If this option is not specified, all geometry fields will be subject to the processing. This option can be combined together with --active-layer.

    --layer-only
        Only modify the layer geometry type. A typical use case is if the layer geometry type is set to unknown and the user knows that the layer only contains geometry of a given type.

    --feature-only
        Only modify the geometry type of features.

    --geometry-type <GEOMETRY-TYPE>
        Change the geometry type to be one of GEOMETRY, POINT, LINESTRING, POLYGON, MULTIPOINT, MULTILINESTRING, MULTIPOLYGON, GEOMETRYCOLLECTION, CURVE, CIRCULARSTRING, COMPOUNDCURVE, SURFACE, CURVEPOLYGON, MULTICURVE, MULTISURFACE, POLYHEDRALSURFACE or TIN. Z, M or ZM suffixes can be appended to the above values to indicate the dimensionality.

        This option is mutually exclusive with --multi, --single, --linear, --curve, and --dim.

    --multi
        Force geometries to MULTI geometry types. e.g. POINT ==> MULTIPOINT. This option is mutually exclusive with --single.

    --single
        Force geometries to non-MULTI geometry types. e.g. MULTIPOINT ==> POINT. This option is mutually exclusive with --multi. MultiPoint or MultiLinestring with more than one component will be kept unmodified. MultiPolygon with more than one component will be merged into a (likely invalid according to OGC Simple Features rule) single polygon, merging all their rings.

    --linear
        Force geometries to linear/non-curve geometry types, approximating arcs with linear segments. The linear approximation can be controlled with configuration options OGR_ARC_STEPSIZE and OGR_ARC_MAX_GAP (specified using --config). e.g. COMPOUNDCURVE ==> LINESTRING. This option is mutually exclusive with --curve.

    --curve
        Force geometries to curve geometry types. e.g. LINESTRING ==> COMPOUNDCURVE or POLYGON ==> CURVEPOLYGON. Points are kept unmodified. This option is mutually exclusive with --linear.

    --dim
        Force geometries to the specified dimension (XY, XYZ, XYM, or XYZM). If the input geometry lacks Z or M components, they will be set to 0. This option is mutually exclusive with --geometry-type.

    --skip
        Skip feature when change of feature geometry type failed (e.g. attempting to force a Point geometry type for a LineString geometry). Otherwise the source geometry will be kept unmodified (which may make it incompatible with the output layer if it does not support mix of geometry types). This option applies both when the target geometry type is defined with --geometry-type, or with any of --multi, --single, --linear, and --curve.

  Advanced options

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

EXAMPLES

  Example 1: Convert a shapefile mixing polygons and multipolygons to a GeoPackage with multipolygons.

            $ gdal vector set-geom-type --geometry-type=MULTIPOLYGON in.shp out.gpkg --overwrite

  Example 2: Convert a GeoPackage with curve geometries to a Shapefile (that does not support them).

            $ gdal vector set-geom-type --linear in.gpkg out.shp --overwrite

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2026